From 9b5ec912547821c59b02f0e5becd3e234312e174 Mon Sep 17 00:00:00 2001
From: Simo Sorce <simo@redhat.com>
Date: Tue, 15 Sep 2015 17:16:05 -0400
Subject: [PATCH 1/5] Fix Makefile so that make dist works

Signed-off-by: Simo Sorce <simo@redhat.com>
---
 Makefile.am | 224 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 224 insertions(+)

diff --git a/Makefile.am b/Makefile.am
index 8dcdb36c9cf6081adf7089d98a42ce6ef5047be0..a9a2d61591b35b35a166d01d4304b8c22a9bbf07 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -246,6 +246,230 @@ noinst_PROGRAMS = makstrdb
 
 noinst_LIBRARIES = libavl.a libldaputil.a
 
+dist_noinst_HEADERS = \
+	include/i18n.h \
+	include/netsite.h \
+	include/base/crit.h \
+	include/base/dbtbase.h \
+	include/base/ereport.h \
+	include/base/file.h \
+	include/base/fsmutex.h \
+	include/base/plist.h \
+	include/base/pool.h \
+	include/base/shexp.h \
+	include/base/systems.h \
+	include/base/systhr.h \
+	include/base/util.h \
+	include/ldaputil/cert.h \
+	include/ldaputil/certmap.h \
+	include/ldaputil/dbconf.h \
+	include/ldaputil/encode.h \
+	include/ldaputil/errors.h \
+	include/ldaputil/extcmap.h \
+	include/ldaputil/init.h \
+	include/ldaputil/ldapauth.h \
+	include/ldaputil/ldaputil.h \
+	include/libaccess/aclerror.h \
+	include/libaccess/acleval.h \
+	include/libaccess/aclglobal.h \
+	include/libaccess/acl.h \
+	include/libaccess/aclproto.h \
+	include/libaccess/aclstruct.h \
+	include/libaccess/attrec.h \
+	include/libaccess/authdb.h \
+	include/libaccess/dbtlibaccess.h \
+	include/libaccess/dnfstruct.h \
+	include/libaccess/ipfstruct.h \
+	include/libaccess/las.h \
+	include/libaccess/nsautherr.h \
+	include/libaccess/nsauth.h \
+	include/libaccess/nserror.h \
+	include/libaccess/symbols.h \
+	include/libaccess/userauth.h \
+	include/libaccess/usi.h \
+	include/libaccess/usrcache.h \
+	include/libadmin/dbtlibadmin.h \
+	include/libadmin/libadmin.h \
+	include/public/netsite.h \
+	include/public/nsapi.h \
+	include/public/base/systems.h \
+	include/public/nsacl/aclapi.h \
+	include/public/nsacl/acldef.h \
+	include/public/nsacl/nserrdef.h \
+	include/public/nsacl/plistdef.h \
+	ldap/include/avl.h \
+	ldap/include/dblayer.h \
+	ldap/include/disptmpl.h \
+	ldap/include/ldaplog.h \
+	ldap/include/ldaprot.h \
+	ldap/include/ldbm.h \
+	ldap/include/portable.h \
+	ldap/include/regex.h \
+	ldap/include/srchpref.h \
+	ldap/include/sysexits-compat.h \
+	ldap/servers/plugins/collation/config.h \
+	ldap/servers/plugins/collation/collate.h \
+	ldap/servers/plugins/collation/orfilter.h \
+	ldap/servers/plugins/chainingdb/cb.h \
+	ldap/servers/plugins/deref/deref.h \
+	ldap/servers/plugins/acctpolicy/acctpolicy.h \
+	ldap/servers/plugins/posix-winsync/posix-wsp-ident.h \
+	ldap/servers/plugins/posix-winsync/posix-group-func.h \
+	ldap/servers/plugins/roles/roles_cache.h \
+	ldap/servers/plugins/usn/usn.h \
+	ldap/servers/plugins/pwdstorage/pwdstorage.h \
+	ldap/servers/plugins/pwdstorage/md5.h \
+	ldap/servers/plugins/acl/acl.h \
+	ldap/servers/plugins/linkedattrs/linked_attrs.h \
+	ldap/servers/plugins/rootdn_access/rootdn_access.h \
+	ldap/servers/plugins/acct_usability/acct_usability.h \
+	ldap/servers/plugins/retrocl/retrocl.h \
+	ldap/servers/plugins/uiduniq/plugin-utils.h \
+	ldap/servers/plugins/memberof/memberof.h \
+	ldap/servers/plugins/replication/cl5_api.h \
+	ldap/servers/plugins/replication/cl4_api.h \
+	ldap/servers/plugins/replication/llist.h \
+	ldap/servers/plugins/replication/repl_shared.h \
+	ldap/servers/plugins/replication/csnpl.h \
+	ldap/servers/plugins/replication/cl5.h \
+	ldap/servers/plugins/replication/repl-session-plugin.h \
+	ldap/servers/plugins/replication/repl.h \
+	ldap/servers/plugins/replication/windows_prot_private.h \
+	ldap/servers/plugins/replication/repl_helper.h \
+	ldap/servers/plugins/replication/repl_objset.h \
+	ldap/servers/plugins/replication/repl5.h \
+	ldap/servers/plugins/replication/cl5_test.h \
+	ldap/servers/plugins/replication/repl5_ruv.h \
+	ldap/servers/plugins/replication/cl5_clcache.h \
+	ldap/servers/plugins/replication/cl4.h \
+	ldap/servers/plugins/replication/cl_crypt.h \
+	ldap/servers/plugins/replication/urp.h \
+	ldap/servers/plugins/replication/winsync-plugin.h \
+	ldap/servers/plugins/replication/windowsrepl.h \
+	ldap/servers/plugins/replication/repl5_prot_private.h \
+	ldap/servers/plugins/pam_passthru/pam_passthru.h \
+	ldap/servers/plugins/syntaxes/syntax.h \
+	ldap/servers/plugins/cos/cos_cache.h \
+	ldap/servers/plugins/sync/sync.h \
+	ldap/servers/plugins/passthru/passthru.h \
+	ldap/servers/plugins/rever/rever.h \
+	ldap/servers/plugins/http/http_client.h \
+	ldap/servers/plugins/http/http_impl.h \
+	ldap/servers/plugins/automember/automember.h \
+	ldap/servers/plugins/mep/mep.h \
+	ldap/servers/slapd/agtmmap.h \
+	ldap/servers/slapd/auth.h \
+	ldap/servers/slapd/csngen.h \
+	ldap/servers/slapd/disconnect_errors.h \
+	ldap/servers/slapd/disconnect_error_strings.h \
+	ldap/servers/slapd/fe.h \
+	ldap/servers/slapd/filter.h \
+	ldap/servers/slapd/getopt_ext.h \
+	ldap/servers/slapd/getsocketpeer.h \
+	ldap/servers/slapd/http.h \
+	ldap/servers/slapd/index_subsys.h \
+	ldap/servers/slapd/intrinsics.h \
+	ldap/servers/slapd/log.h \
+	ldap/servers/slapd/mozldap.h \
+	ldap/servers/slapd/openldapber.h \
+	ldap/servers/slapd/poll_using_select.h \
+	ldap/servers/slapd/prerrstrs.h \
+	ldap/servers/slapd/protect_db.h \
+	ldap/servers/slapd/proto-slap.h \
+	ldap/servers/slapd/pw.h \
+	ldap/servers/slapd/secerrstrs.h \
+	ldap/servers/slapd/slap.h \
+	ldap/servers/slapd/slapi-plugin-compat4.h \
+	ldap/servers/slapd/slapi-plugin.h \
+	ldap/servers/slapd/slapi-private.h \
+	ldap/servers/slapd/snmp_collator.h \
+	ldap/servers/slapd/sslerrstrs.h \
+	ldap/servers/slapd/statechange.h \
+	ldap/servers/slapd/uuid.h \
+	ldap/servers/slapd/vattr_spi.h \
+	ldap/servers/slapd/views.h \
+	ldap/servers/slapd/back-ldbm/attrcrypt.h \
+	ldap/servers/slapd/back-ldbm/back-ldbm.h \
+	ldap/servers/slapd/back-ldbm/dblayer.h \
+	ldap/servers/slapd/back-ldbm/idlapi.h \
+	ldap/servers/slapd/back-ldbm/import.h \
+	ldap/servers/slapd/back-ldbm/ldbm_config.h \
+	ldap/servers/slapd/back-ldbm/perfctrs.h \
+	ldap/servers/slapd/back-ldbm/proto-back-ldbm.h \
+	ldap/servers/slapd/back-ldbm/vlv_key.h \
+	ldap/servers/slapd/back-ldbm/vlv_srch.h \
+	ldap/servers/slapd/tools/ldaptool.h \
+	ldap/servers/slapd/tools/ldaptool-sasl.h \
+	ldap/servers/slapd/tools/ldclt/ldap-private.h \
+	ldap/servers/slapd/tools/ldclt/ldclt.h \
+	ldap/servers/slapd/tools/ldclt/port.h \
+	ldap/servers/slapd/tools/ldclt/remote.h \
+	ldap/servers/slapd/tools/ldclt/scalab01.h \
+	ldap/servers/slapd/tools/ldclt/utils.h \
+	ldap/servers/slapd/tools/rsearch/addthread.h \
+	ldap/servers/slapd/tools/rsearch/infadd.h \
+	ldap/servers/slapd/tools/rsearch/nametable.h \
+	ldap/servers/slapd/tools/rsearch/rsearch.h \
+	ldap/servers/slapd/tools/rsearch/sdattable.h \
+	ldap/servers/slapd/tools/rsearch/searchthread.h \
+	ldap/servers/snmp/ldap-agent.h \
+	ldap/systools/pio.h \
+	lib/base/lexer_pvt.h \
+	lib/base/plist_pvt.h \
+	lib/ldaputil/ldaputili.h \
+	lib/libaccess/access_plhash.h \
+	lib/libaccess/aclcache.h \
+	lib/libaccess/aclpriv.h \
+	lib/libaccess/aclscan.h \
+	lib/libaccess/acl.tab.h \
+	lib/libaccess/aclutil.h \
+	lib/libaccess/lasdns.h \
+	lib/libaccess/las.h \
+	lib/libaccess/lasip.h \
+	lib/libaccess/ldapauth.h \
+	lib/libaccess/oneeval.h \
+	lib/libaccess/parse.h \
+	lib/libaccess/permhash.h \
+	lib/libsi18n/getstrmem.h \
+	lib/libsi18n/gsslapd.h \
+	lib/libsi18n/reshash.h \
+	lib/libsi18n/txtfile.h \
+	$(NULL)
+
+dist_noinst_DATA = \
+	buildnum.pl \
+	dirsrv.pc.in \
+	ldap/admin/src/*.pl \
+	ldap/admin/src/*.in \
+	ldap/admin/src/scripts/*.in \
+	ldap/admin/src/scripts/*.ldif \
+	ldap/admin/src/scripts/*.pl \
+	ldap/admin/src/scripts/*.pm \
+	ldap/admin/src/scripts/*.py \
+	ldap/admin/src/scripts/*.sh \
+	ldap/admin/src/scripts/migrate-ds.res \
+	ldap/ldif/*.in \
+	ldap/ldif/*.ldif \
+	ldap/schema/*ldif \
+	ldap/schema/slapd-collations.conf \
+	ldap/servers/slapd/mkDBErrStrs.pl \
+	ldap/servers/slapd/tools/rsearch/scripts/dbgen* \
+	ldap/servers/snmp/ldap-agent.conf \
+	ldap/servers/snmp/redhat-directory.mib \
+	lib/ldaputil/certmap.conf \
+	m4 \
+	rpm/389-ds-base.spec.in \
+	rpm/389-ds-base-devel.README \
+	rpm/389-ds-base-git.sh \
+	selinux \
+	README \
+	LICENSE \
+	LICENSE.* \
+	VERSION.sh \
+	wrappers/*.in \
+	wrappers/systemd.template.sysconfig \
+	$(NULL)
+
 #------------------------
 # Installed Files
 #------------------------
-- 
2.4.3