From 2cbbbcdf51f47ee253cb01bf0a705c06c2732782 Mon Sep 17 00:00:00 2001
From: Noriko Hosoi <nhosoi@redhat.com>
Date: Sun, 7 Feb 2016 16:08:56 -0800
Subject: [PATCH] Ticket 48363 - Support for rfc3673 '+' to return operational
 attributes

Description: commit 08c40e8a35a3611a0ac3ca30a86d40a17676ba84 had a copy&
paste error.  Replacing slapi_rwlock_unlock with slapi_rwlock_rdlock.
---
 ldap/servers/slapd/features.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ldap/servers/slapd/features.c b/ldap/servers/slapd/features.c
index 64a2825..a4e8872 100644
--- a/ldap/servers/slapd/features.c
+++ b/ldap/servers/slapd/features.c
@@ -44,7 +44,7 @@ slapi_register_supported_feature( char *featureoid )
 int
 slapi_get_supported_features_copy( char ***ftroidsp )
 {
-    slapi_rwlock_unlock(supported_features_lock);
+    slapi_rwlock_rdlock(supported_features_lock);
     if ( ftroidsp != NULL ) {
         *ftroidsp = charray_dup(supported_features);
     }
-- 
2.4.3